Package org.gradle.api.tasks.scala

## Class ScalaDoc

- java.lang.Object
- - org.gradle.api.internal.AbstractTask
  - - org.gradle.api.DefaultTask
    - - org.gradle.api.internal.ConventionTask
      - - org.gradle.api.tasks.SourceTask
        - - org.gradle.api.tasks.scala.ScalaDoc

- All Implemented Interfaces:
    `java.lang.Comparable<Task>`, `org.gradle.api.internal.DynamicObjectAware`, `org.gradle.api.internal.IConventionAware`, `org.gradle.api.internal.TaskInternal`, `Named`, `ExtensionAware`, `Task`, `PatternFilterable`, `Configurable<Task>`

      @CacheableTask
      public abstract class ScalaDoc
      extends SourceTask

  Generates HTML API documentation for Scala source files.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.gradle.api.Task

      `Task.Namer`

  - ### Field Summary

    - ### Fields inherited from interface org.gradle.api.Task

      `TASK_ACTION, TASK_CONSTRUCTOR_ARGS, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ScalaDoc()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `generate()` |
    `protected abstract org.gradle.api.internal.project.IsolatedAntBuilder` | `getAntBuilder()` |
    `FileCollection` | `getClasspath()` | Returns the classpath to use to locate classes referenced by the documented source.
    `ConfigurableFileCollection` | `getCompilationOutputs()` | Returns the compilation outputs produced by the sources that are generating Scaladoc.
    `java.io.File` | `getDestinationDir()` | Returns the directory to generate the API documentation into.
    `protected FileTree` | `getFilteredCompilationOutputs()` | Returns the compilation outputs needed by Scaladoc filtered to include TASTy files.
    `Property<JavaLauncher>` | `getJavaLauncher()` | A JavaLauncher used to run the Scaladoc tool.
    `protected abstract JavaToolchainService` | `getJavaToolchainService()` |
    `Property<java.lang.String>` | `getMaxMemory()` | Returns the amount of memory allocated to this task.
    `protected abstract ObjectFactory` | `getObjectFactory()` |
    `FileCollection` | `getScalaClasspath()` | Returns the classpath to use to load the ScalaDoc tool.
    `ScalaDocOptions` | `getScalaDocOptions()` | Returns the ScalaDoc generation options.
    `FileTree` | `getSource()` | Returns the source for this task, after the include and exclude patterns have been applied.
    `java.lang.String` | `getTitle()` | Returns the documentation title.
    `protected abstract WorkerExecutor` | `getWorkerExecutor()` |
    `void` | `setClasspath​(FileCollection classpath)` |
    `void` | `setDestinationDir​(java.io.File destinationDir)` |
    `void` | `setScalaClasspath​(FileCollection scalaClasspath)` |
    `void` | `setScalaDocOptions​(ScalaDocOptions scalaDocOptions)` |
    `void` | `setTitle​(java.lang.String title)` |

    - ### Methods inherited from class org.gradle.api.tasks.SourceTask

      `exclude, exclude, exclude, exclude, getExcludes, getIncludes, getPatternSet, getPatternSetFactory, include, include, include, include, setExcludes, setIncludes, setSource, setSource, source`

    - ### Methods inherited from class org.gradle.api.internal.ConventionTask

      `conventionMapping, conventionMapping, getConventionMapping`

    - ### Methods inherited from class org.gradle.api.DefaultTask

      `compareTo, configure, dependsOn, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExtensions, getFinalizedBy, getGroup, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOutputs, getPath, getProject, getShouldRunAfter, getState, getTaskDependencies, getTemporaryDir, getTimeout, hasProperty, mustRunAfter, onlyIf, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, usesService`

    - ### Methods inherited from class org.gradle.api.internal.AbstractTask

      `acceptServiceReferences, appendParallelSafeAction, doNotTrackState, getAsDynamicObject, getConvention, getIdentityPath, getImpliesSubProjects, getLifecycleDependencies, getOnlyIf, getReasonNotToTrackState, getReasonTaskIsIncompatibleWithConfigurationCache, getRequiredServices, getServices, getSharedResources, getStandardOutputCapture, getTaskActions, getTaskIdentity, getTemporaryDirFactory, hasTaskActions, injectIntoNewInstance, isCompatibleWithConfigurationCache, isEnabled, isHasCustomActions, notCompatibleWithConfigurationCache, prependParallelSafeAction, setImpliesSubProjects`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.gradle.api.Task

      `doNotTrackState, getConvention, notCompatibleWithConfigurationCache`

- - ### Constructor Detail

    - #### ScalaDoc

          public ScalaDoc()

  - ### Method Detail

    - #### getDestinationDir

          @OutputDirectory
          public java.io.File getDestinationDir()

      Returns the directory to generate the API documentation into.

    - #### setDestinationDir

          public void setDestinationDir​(java.io.File destinationDir)

    - #### getSource

          @PathSensitive(RELATIVE)
          public FileTree getSource()

      Returns the source for this task, after the include and exclude patterns have been applied. Ignores source files which do not exist.

      The `PathSensitivity` for the sources is configured to be `PathSensitivity.RELATIVE`.

      Overrides:
        `getSource` in class `SourceTask`
      Returns:
        The source.

    - #### getFilteredCompilationOutputs

          @InputFiles
          @IgnoreEmptyDirectories
          @PathSensitive(RELATIVE)
          protected FileTree getFilteredCompilationOutputs()

      Returns the compilation outputs needed by Scaladoc filtered to include TASTy files.

      NOTE: This is only useful with Scala 3 or later. Scala 2 only processes source files.

      Returns:
        the compilation outputs produced from the sources
      Since:
        7.3

    - #### getCompilationOutputs

          @Internal
          public ConfigurableFileCollection getCompilationOutputs()

      Returns the compilation outputs produced by the sources that are generating Scaladoc.
      Returns:
        the compilation outputs produced from the sources
      Since:
        7.3

    - #### getClasspath

          @Classpath
          public FileCollection getClasspath()

      Returns the classpath to use to locate classes referenced by the documented source.

      Returns:
        The classpath.

    - #### setClasspath

          public void setClasspath​(FileCollection classpath)

    - #### getScalaClasspath

          @Classpath
          public FileCollection getScalaClasspath()

      Returns the classpath to use to load the ScalaDoc tool.

    - #### setScalaClasspath

          public void setScalaClasspath​(FileCollection scalaClasspath)

    - #### getScalaDocOptions

          public ScalaDocOptions getScalaDocOptions()

      Returns the ScalaDoc generation options.

    - #### setScalaDocOptions

          public void setScalaDocOptions​(ScalaDocOptions scalaDocOptions)

    - #### getTitle

          @Nullable
          @Optional
          @Input
          public java.lang.String getTitle()

      Returns the documentation title.

    - #### setTitle

          public void setTitle​(@Nullable
                               java.lang.String title)

    - #### getMaxMemory

          @Internal
          public Property<java.lang.String> getMaxMemory()

      Returns the amount of memory allocated to this task. Ex. 512m, 1G
      Since:
        6.5

    - #### getJavaLauncher

          public Property<JavaLauncher> getJavaLauncher()

      A JavaLauncher used to run the Scaladoc tool.
      Since:
        7.2

    - #### generate

          protected void generate()

    - #### getObjectFactory

          @Inject
          protected abstract ObjectFactory getObjectFactory()

    - #### getAntBuilder

          @Inject
          protected abstract org.gradle.api.internal.project.IsolatedAntBuilder getAntBuilder()

    - #### getWorkerExecutor

          @Inject
          protected abstract WorkerExecutor getWorkerExecutor()

    - #### getJavaToolchainService

          @Inject
          protected abstract JavaToolchainService getJavaToolchainService()